/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// action.h Fri Jun 8 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _ACTION_H_
#define _ACTION_H_

#include "angle.h"
#include "vector2d.h"
#include "servercommand.h"
#include "worldmodel.h"
//#include <vector.h>
#include <iostream.h>
#include <fstream.h>
#include "actionlist.h"

class ActionList;

class Action
{
public:
	Action();
	virtual ~Action();
	virtual ServerCommand* translate() const = 0;
	virtual Action* copy() const = 0;
	int getDuration() const;
	void setDuration(int _iDuration);
	
  virtual ostream& ostream_insert(ostream& _out) const;
  virtual ofstream& ofstream_insert(ofstream& _fout) const=0;

private:
	// iDuration represents the number of timesteps
	// an action will take.
	int iDuration;	
};

ostream& operator<<(ostream& _out, const Action& _act);
ofstream& operator<<(ofstream& _fout, const Action& _act);

//typedef vector<Action*> ActionList;

#endif
