/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// changeviewaction.h Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef CHANGEVIEWACTION_H
#define CHANGEVIEWACTION_H

#include "action.h"
#include "changeviewcommand.h"

/**
  *@author UVa RoboCup Team
  */

class ChangeViewAction : public Action  {
public: 
	ChangeViewAction();
    ChangeViewAction(view_width _vwWidth, view_quality _vqQuality);
	virtual ~ChangeViewAction();
	
	virtual ServerCommand* translate() const;
	virtual Action* copy() const;
	
    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;

    void setViewWidth(view_width _vwWidth);
    void setViewQuality(view_quality _vqQuality);

    view_width getViewWidth() const;
    view_quality getViewQuality() const;

private:
	view_width vwWidth;
	view_quality vqQuality;


	
};

#endif
