/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// runaction.h Fri Jun 29 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _RUNACTION_H_
#define _RUNACTION_H_

#include "action.h"

#define MIN_TURN_WINDOW 0.1
#define MAX_TURN_WINDOW PI_8
#define MAX_DASH_POWER 100

class RunAction : public Action
{
public: 
	RunAction();
	RunAction(const Angle& _aDirection, double _dIntensity);	
	virtual ~RunAction();
	virtual Action* copy() const;
	virtual ServerCommand* translate() const;

	void setDirection(const Angle& _aDirection);
	void setIntensity(double dIntensity);
	
	Angle getDirection() const;
	double getIntensity() const;

    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;

private:
	Angle aDirection;
	double dIntensity;
	static bool fAlreadyTurned;

};

#endif
