/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// saycommand.cpp Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "saycommand.h"

#undef TRACE
#define TRACE(cmd)

SayCommand::SayCommand() : ServerCommand(0)
{
}

SayCommand::SayCommand(const char* _pcMessage) : ServerCommand(0)
{
    setMessage(_pcMessage);
}

SayCommand::~SayCommand()
{
}

Comm& SayCommand::comm_insert(Comm &_cmConnection) const
{
    char msg [MAX_SAY_MSG_SIZE];

    sprintf(msg, "(say %s)", pcMessage);

    if (_cmConnection.sendToServer(msg) == COMM_OK)
    {
        TRACE("PlayerComm: agent sent " << msg);
    }
    else
    {
        ALERT("servertime_here" << " PlayerComm: agent cannot send " << msg << " to server" );
    }

	return _cmConnection;
}

void SayCommand::setMessage(const char* _pcMessage)
{
    if(strlen(_pcMessage) > MAX_SAY_MSG_SIZE)
    {
        TRACE("SayCommand: Attempt to prepare msg for sending that exceeds max. length");
    }

    // copy the message in
    strcpy(pcMessage, _pcMessage);
}
