/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// centerperception.h Fri Jul 6 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _CENTERPERCEPTION_H_
#define _CENTERPERCEPTION_H_

#include "perception.h"
#include "types.h"
#include "constants.h"

class CenterPerception : public Perception
{
public: 
	CenterPerception(const WorldModel &_wmWorld);
	virtual ~CenterPerception();


	Vector2d getBallAbsPos();
	bool inAttackingThird(WorldObject _woObj);
	bool inMiddleThird(WorldObject _woObj);
	bool inDefensiveThird(WorldObject _woObj);
	bool inOurPenaltyArea(WorldObject _woObj);
  WorldBall getBall();

	double distToVirtCenter (double _dVirtCenter);



	Angle getBodyDir();
	int getBallAge() const;
	bool isActiveMode() const;

	
	bool isGoalie() const { return wmWorld.getClientPlayer().isGoalie(); }
};

#endif
