
/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// collisionperception.cpp Tue Jul 10 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "collisionperception.h"

CollisionPerception::CollisionPerception(const WorldModel& _wmWorld) : Perception(_wmWorld)
{
}

CollisionPerception::~CollisionPerception()
{
}

// function duplicated from GoHomePerception
bool CollisionPerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_PLAY_ON) ||
        (pmTemp == PLAY_MODE_DROP_BALL)
        ) return true;

    return false;
}

Vector2d CollisionPerception::getClosestOpponent() const
{
	WorldPlayer wpPlayer;
	WorldPlayer wpClientPlayer = wmWorld.getClientPlayer();
	
	double dDist;
	double dShortestDist = INFINITY;
	
	Vector2d vShortest; // holds a vector to the relative position of the nearest player
	
	for(int i = 1; i <= MAX_PLAYER; i++)
	{
		// check other team
		wpPlayer = wmWorld.getOtherPlayer(i);
		if (wpPlayer.isKnown())
		{
      		dDist = dist(wpPlayer.getAbsPosition(), wpClientPlayer.getAbsPosition());      		
      		if (dDist < dShortestDist)
  	    	{
  		    	dShortestDist = dDist;
  			    vShortest = relPos(wpPlayer);
      		}
      	}

	} // end for()
	
	return vShortest;
}



bool CollisionPerception::atBall() const
{
	ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
	WorldBall wbBall = wmWorld.getWorldBall();
	
	return (relPos(wbBall).getLength() < KICKRANGE);
}
