/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// combologic.cpp Wed Jul 25 2001
// Description: This file holds the functions for double dispatch
//				on recommendations (see More Effective C++ by Scott
//				Meyers, Item 31)
//				Add new combination functions to intializeComboMap
//////////////////////////////////////////////////////////////////////
#include "behindballrecommendation.h"
#include "backlinerecommendation.h"
#include "centerrecommendation.h"
#include "puntrecommendation.h"
#include "goaliepositionrecommendation.h"


//#include "runaction.h"

#include "recommendation.h"
#include "combologic.h"
//#include <map>
//#include <typeinfo>


using namespace std;


Recommendation* defaultCombine(const Recommendation &rec1, const Recommendation &rec2);


Recommendation* combine(const Recommendation& rec1, const Recommendation& rec2)
{
  return defaultCombine(rec1, rec2);
}

Recommendation* defaultCombine(const Recommendation &rec1, const Recommendation &rec2)
{		
	ENSURE(rec1 >= rec2);
//		if (rec1 < rec2)
//			return defaultCombine(rec2, rec1);

        Recommendation* recfinal = rec1.copy();
		
        ActionList alList = rec2.getActionList();
        					

        while(!alList.empty())
        {
            Action* pacAction = alList.front();
            alList.pop_front();
            if(pacAction->getDuration() == 0)
            {
                recfinal->addAction(*pacAction);
                delete pacAction;
                pacAction = NULL;
            }
        }

        return recfinal;

}














