/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// cornerkickperception.cpp Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "cornerkickperception.h"

CornerKickPerception::CornerKickPerception(const WorldModel& _wmWorld) : Perception(_wmWorld)
{
}

CornerKickPerception::~CornerKickPerception()
{
}

bool CornerKickPerception::isActiveMode () const
{
  play_mode pmTemp = wmWorld.getPlayMode();

  return (pmTemp == PLAY_MODE_CORNER_KICK_US);
}

bool CornerKickPerception::inPosition () const
{
  Vector2d vBallPos = wmWorld.getWorldBall().getAbsPosition();
  Vector2d vPlayerPos = wmWorld.getClientPlayer().getAbsPosition();
  bool res = false;

  if (vPlayerPos.getX() > (vBallPos.getX() + 1.0))
    {
      if (vBallPos.getY () < -1.0)
	{
	  res = vPlayerPos.getY() < (vBallPos.getY() - 3.0);
	}
      else
	{
	  res = vPlayerPos.getY() > (vBallPos.getY() + 3.0);
	}
    }

  return res;  
}

Angle CornerKickPerception::getRunAngle() const
{
  Vector2d vBallPos = wmWorld.getWorldBall().getAbsPosition();

  if (vBallPos.getY () < -1.0)
    {
      vBallPos.setY (vBallPos.getY() - 5.0);
    }
  else
    {
      vBallPos.setY (vBallPos.getY() + 5.0);
    }

  vBallPos.setX (vBallPos.getX () + 2.0);

  return relPos(vBallPos).getAngle();
}

