/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// disperseperception.cpp Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "disperseperception.h"

DispersePerception::DispersePerception(const WorldModel &_wmWorld) : Perception(_wmWorld)
{
}

DispersePerception::~DispersePerception()
{
}


WorldPlayer DispersePerception::ourTeamDistIndex(int _iIndex)
{
	//ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
	int iClientNum = wmWorld.getClientPlayer().getNumber();

	//finds out the number of teammates client knows well enough for disperse
	int iArray = 0;
	for (int h = 1; h <= MAX_PLAYER; ++h)
		{
		if (h != iClientNum)
			{
			if ( wmWorld.getOurPlayer(h).isYoung() )
				++iArray;
			}
		}

	// create array for distances to ball
	WorldPlayer wpTeammateArray[iArray];
  WorldPlayer temp;
	
  //sets up teammate array
  int iArrayCount = 0;
	for (int k = 1; k <= MAX_PLAYER; ++k)
		{
		if (k != iClientNum)
			if ( wmWorld.getOurPlayer(k).isYoung() )
			{
				wpTeammateArray[iArrayCount] = wmWorld.getOurPlayer(k);
				++iArrayCount;
			}
		}

	// get distance from the ball and resort the distance array
	for (int i = 0; i < iArray; ++i)
	{
		for (int j = 0; j < i; ++j)
		{
			if ( norm( relPos(wpTeammateArray[j]) ) > norm( relPos(wpTeammateArray[i]) ) )
			{
				temp = wpTeammateArray [i];
				wpTeammateArray [i] = wpTeammateArray [j];
				wpTeammateArray [j] = temp;
			}
		}
  }

	if ( iArray >= _iIndex )
		return ( wpTeammateArray[_iIndex - 1] );

	return WorldPlayer();

 }

double DispersePerception::getMyX()
{
	return ( wmWorld.getClientPlayer().getAbsPosition().getX() );
}

void DispersePerception::checkVec(Vector2d& _vDisVec)
{
  if ( (wmWorld.getClientPlayer().getAbsPosition().getX() < -0.5 * FIELD_LENGTH + 9) && (_vDisVec.getX() < 0.0) )
    _vDisVec.setX(0.0);
  
}

int DispersePerception::getBallAge() const
{
	return ( wmWorld.getWorldBall().getAge() );
}

bool DispersePerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_PLAY_ON) ||
        (pmTemp == PLAY_MODE_DROP_BALL)
      ) return true;

    return false;
}

