/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// freekickbehavior.cpp Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "freekickbehavior.h"
#include "kickaction.h"
#include "turnaction.h"
#include "runaction.h"

FreeKickBehavior::FreeKickBehavior(const WorldModel& _wmWorld) : perFreeKick(_wmWorld), iStartTime(0)
{
}

FreeKickBehavior::~FreeKickBehavior()
{
}

bool FreeKickBehavior::isUseful()
{
  if (!perFreeKick.isActiveMode ())
    {
      iStartTime = perFreeKick.getTime ();
      return false;
    }

  if (!perFreeKick.amIClosestToBall(1)) 
    {
      return false;
    }

  if (!perFreeKick.inPosition())
    {
      return true;
    }

  if (perFreeKick.getTime () - iStartTime < 100)
    {
      return true;
    }
  
  return false;
}

void FreeKickBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recFreeKick;
  recFreeKick.szBehaviorName = "freekick";
 
  if (perFreeKick.inPosition ())
    {
      RunAction raRun;
      raRun.setDirection(perFreeKick.getRunAngle());
      raRun.setIntensity(0);	  
      recFreeKick.setGrade(100);
      recFreeKick.addAction(raRun);
      recList.insert(recFreeKick);
    }
  else
    {
      RunAction raRun;
      raRun.setDirection(perFreeKick.getRunAngle());
      
      if(perFreeKick.getStamina() > 3000) 
	raRun.setIntensity(40);
      else
	raRun.setIntensity(0);	  
      
      recFreeKick.addAction(raRun);
      recFreeKick.addAction(raRun);
      recFreeKick.addAction(raRun);
      
      recFreeKick.setGrade(100);
      recList.insert(recFreeKick);
    }
}



