/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// GoalKickStallbehavior.cpp Mon Jul 2 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "goalkickstallbehavior.h"
#include "runaction.h"

GoalKickStallBehavior::GoalKickStallBehavior(const WorldModel &_wmWorld) : perGoalKickStall(_wmWorld)
{
  
}

GoalKickStallBehavior::~GoalKickStallBehavior()
{}

bool GoalKickStallBehavior::isUseful()
{
  if (!perGoalKickStall.isGoalKickMode ())
    {
      iStartTime = perGoalKickStall.getTime ();
      return false;
    }

  if (perGoalKickStall.getTime () - iStartTime < 100)
    {
      return true;
    }
  
  return false;

}

void GoalKickStallBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recGoalKick;
  recGoalKick.szBehaviorName = "goalkick";

  RunAction raRun;
  raRun.setDirection(0.0);
  raRun.setIntensity(0);	  
  recGoalKick.setGrade(100);
  recGoalKick.addAction(raRun);
  recList.insert(recGoalKick);
}

