
/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gohomebehavior.cpp Tue Jul 10 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "gohomebehavior.h"
#include "runaction.h"

GoHomeBehavior::GoHomeBehavior(const WorldModel &_wmWorld, const Vector2d &_vHome) : perGoHome(_wmWorld), vHome(_vHome)
{
}

GoHomeBehavior::~GoHomeBehavior()
{
}

bool GoHomeBehavior::isUseful()
{

	// If playmode is not play_on this behavior is not useful
	if(!perGoHome.isActiveMode()) return false;
	
	// If we are the player with the ball we would rather catch the ball than go home
	if(perGoHome.atBall()) return false; //probably should calc. isClosestToBall()
	
	// if we're not home then this behavior is useful	
	return (!perGoHome.isHome(vHome));
}

void GoHomeBehavior::evaluate(RecommendationList& recList)
{
	Recommendation recFinal;
    recFinal.szBehaviorName = "gohome";
    	
	RunAction raRun;
	
	raRun.setDirection(perGoHome.relPos(vHome).getAngle());
	raRun.setIntensity(50);
	
	recFinal.addAction(raRun);
	
	// Get the distance we are away from home
	double dDistHome = perGoHome.relPos(vHome).getLength();
	
	if(dDistHome > 50) // approx. half the field
       	recFinal.setGrade(100);	
    else
    	recFinal.setGrade( 100 ); // (dDistHome / 50) * 100 );

	recList.insert(recFinal);
	return ;
}

