/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gotocornerbehavior.cpp Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "gotocornerbehavior.h"
#include "dribbleaction.h"
#include "turnaction.h"
#include "runaction.h"
#include "changeviewaction.h"

GoToCornerBehavior::GoToCornerBehavior(const WorldModel &_wmWorld) : perGoToCorner(_wmWorld)
{
}

GoToCornerBehavior::~GoToCornerBehavior()
{
}

bool GoToCornerBehavior::isUseful()
{
  //if (!fAlreadyKicked && perGoToGoal.atBall() && !perGoToGoal.ballMovingFaster())
  //if (!perGoToGoal.ballTooOld() && ((perGoToGoal.atBall() || perGoToGoal.willPassBall()) || (fAlreadyKicked && perGoToGoal.ballAged())))
  
  //if (!perGoToGoal.ballTooOld() && (perGoToGoal.atBall()  || (fAlreadyKicked && perGoToGoal.ballAged())))
  
  if (!perGoToCorner.ballTooOld() && perGoToCorner.atBall())
    {
      return true;
      //if (iUseful == 3) iUseful = 0; else iUseful++;
    }
  
  if (perGoToCorner.isOurGoalKick ())
    {
      return true;
    }

  fAlreadyKicked = false;
  
  return false;
}

void GoToCornerBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recGoToGoal;
  recGoToGoal.szBehaviorName = "gotogoal";	

  if (perGoToCorner.isOurGoalKick ())
    {
      Recommendation recFinal;
      recFinal.szBehaviorName = "bogusgotocorner";

      RunAction raRun;

      if (perGoToCorner.inTopHalf ())
	{
	  raRun.setDirection (perGoToCorner.relPos (Vector2d(0.0, -30.0)).getAngle());
	}
      else
	{
	  raRun.setDirection (perGoToCorner.relPos (Vector2d(0.0, 30.0)).getAngle());
	}

      raRun.setIntensity (50);
      recFinal.addAction (raRun);	
      recFinal.addAction (raRun);	
      recFinal.setGrade (98);
      recList.insert (recFinal);
    }
  else
    {
      // TODO: perhaps turning to the ball after you kick should be in a separate behavior?
      /*	if (fAlreadyKicked)
		{
		TurnAction taTurnToBall(aLastKickDir);
		recGoToGoal.addAction(taTurnToBall);
		recGoToGoal.setGrade(90);
		
		fAlreadyKicked = false;
		recList.insert(recGoToGoal);
		return;
		}
      */
      Angle aDribbleAngle = perGoToCorner.angleToKick();
      aLastKickDir = aDribbleAngle;
      
      DribbleAction daDribble(aDribbleAngle);
      recGoToGoal.addAction(daDribble);
      
      if(!perGoToCorner.correctViewMode(VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH))
	{
	  ChangeViewAction cvaNewView(VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH);		
	  recGoToGoal.addAction(cvaNewView);
	}
      
      recGoToGoal.setGrade(88);
      
      fAlreadyKicked = true;
      
      recList.insert(recGoToGoal);
    }
}

