/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// kickoffperception.cpp Wed Jul 11 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "kickoffperception.h"

KickoffPerception::KickoffPerception(const WorldModel& _wmWorld) : Perception(_wmWorld)
{
}

KickoffPerception::~KickoffPerception()
{
}

bool KickoffPerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_BEFORE_KICK_OFF ) ||
        (pmTemp == PLAY_MODE_GOAL_US) ||
        (pmTemp == PLAY_MODE_GOAL_THEM) ||
        (pmTemp == PLAY_MODE_HALF_TIME)
//        || (pmTemp == PLAY_MODE_KICKOFF_THEM)
      ) return true;

    return false;

}

Angle KickoffPerception::getBodyDir() const
{
  ClientWorldPlayer cwpClient = wmWorld.getClientPlayer();
  
  return cwpClient.getBodyDir();
}
	
Vector2d KickoffPerception::getMyKickoffPos() const
{
  ClientWorldPlayer cwpPlayer = wmWorld.getClientPlayer();
  
  if(cwpPlayer.isGoalie())
    {
      return Vector2d (-49.5, 0);
    }
  
  int iNumber = cwpPlayer.getNumber();
  
  ENSURE((iNumber > 0) && (iNumber <= MAX_PLAYER));
  
  return KICKOFF_POSITIONS[iNumber - 1];
}

bool KickoffPerception::atPosition() const
{
  ClientWorldPlayer cwpPlayer = wmWorld.getClientPlayer();
  
  if ( cwpPlayer.getAbsPosition().isApprox(getMyKickoffPos()) )
    return true;
  
  return false;
}
