//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members
// of the Mainz Rolling Brains RoboCup Team
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
//   $Id: recommendation.h,v 1.12 2001/07/26 22:45:23 kmb3s Exp $	
//   $Manager: cm$
//
//   recommendation.h
//
////////////////////////////////////////////////////////////////////////

#ifndef _RECOMENDATION_H_
#define _RECOMENDATION_H_

#include <iostream.h>
#include <fstream.h>
#include <string>

#include "grade.h"
#include "action.h"

class Recommendation
{
public:
	Recommendation();
	Recommendation::Recommendation(const Recommendation& rhs);
	virtual ~Recommendation();
	
	void setGrade(const Grade &_gGrade);
	//void addAction(Action* _pacAction);
	void addAction(const Action& _acAction);
	void setActionList(const ActionList& _alActions);
	
	Grade getGrade() const;
	const ActionList& getActionList() const;
	string getBehaviorName() const;
	
	bool operator==(const Recommendation& rec) const;
	bool operator>(const Recommendation& rec) const;
	bool operator<(const Recommendation& rec) const;
	bool operator>=(const Recommendation& rec) const;
	bool operator<=(const Recommendation& rec) const;
	Recommendation& operator=(const Recommendation &rec);	
	
    virtual Recommendation* copy() const;
	
	string szBehaviorName; // used only for logging	
	
  ostream& ostream_insert(ostream& _out) const;
  ofstream& ofstream_insert(ofstream& _fout) const;

  // combination functions
//	virtual ActionList combine(const ActionList &_alActions) const;	

private:
	Grade gGrade;
	ActionList alActions;
};

ostream& operator<<(ostream& _out, const Recommendation& _rec);
ofstream& operator<<(ofstream& _fout, const Recommendation& _rec);


#endif
