/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// audiodata.h Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef AUDIODATA_H
#define AUDIODATA_H

#include "sensordata.h"

/**
  *@author UVA RoboCup Team
  */

class AudioData : public SensorData
{
public: 
	AudioData();
	AudioData(int _time);
	~AudioData();

	virtual WorldModel& worldmodel_insert(WorldModel &_wmWorld) const;

/*  void setSender(sender_type _sender);
  sender_type getSender();

  void setMessage(char *_message);
  char* getMessage();

  void setPlayMode(play_mode _mode);
  play_mode getPlayMode();

  void setScore(int _score);
  int getScore();

  void setSenderDir(double _sender_dir);
  double getSenderDir();

  void setSenderName(char *_sender_name);
  char *getSenderName(); */


  // from sensor.h
  // for type == SENSOR_TYPE_HEAR

  sender_type sender;                 // always valid when S_T_HEAR
  char message[MAX_SAY_MSG_SIZE];     // always valid when S_T_HEAR
  play_mode mode;		      // only valid if sender == SENDER_REFEREE
  int score;                          // only valid if mode==GOAL_US||GOAL_THEM
  double sender_dir;	              // only valid if sender == SENDER_DIR
  char sender_name[MAX_SAY_MSG_SIZE]; // only valid if sender == SENDER_PLAYER
};

#endif
