/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// sensordata.cpp Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "sensordata.h"

SensorData::SensorData()
{
  time = UNKNOWN;
}

SensorData::SensorData(int _time)
{
  time = _time;
}

SensorData::~SensorData()
{

}

void SensorData::setTime(int _time)
{
  time = _time;
}

int SensorData::getTime() const
{
  return time;
}

ostream& SensorData::ostream_insert(ostream &sout) const
{
  return sout;
}

WorldModel& SensorData::worldmodel_insert(WorldModel &_wmWorld) const
{
  _wmWorld.setTime(getTime());

  return _wmWorld;
}

CoachWorldModel& SensorData::worldmodel_insert(CoachWorldModel &_cwmWorld) const
{
  _cwmWorld.setTime(getTime());

  return _cwmWorld;
}

ostream& operator<<(ostream &sout, const SensorData &d)
{
  return d.ostream_insert(sout);
}

//WorldModel& operator+=(WorldModel &_wmWorld, const SensorData &_sdData)
//{
//	return _sdData.worldmodel_insert(_wmWorld);
//}
//
//CoachWorldModel& operator+=(CoachWorldModel &_cwmWorld, const SensorData &_sdData)
//{
//	return _sdData.worldmodel_insert(_cwmWorld);
//}

