/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// sensordata.h Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _SENSORDATA_H_
#define _SENSORDATA_H_

#include <iostream.h>

#include "constants.h"
#include "types.h"
#include "worldmodel.h"
#include "coachworldmodel.h"

// NOTE: functions or variables with the comment coach facility may eventually
//			 need to be moved to a derived coach class
class SensorData
{
public:
	SensorData();
	SensorData(int _time);
	virtual ~SensorData();
    void setTime(int _time);
    int getTime() const; // TODO: use private member vars and inspectors for all SensorData classes
	virtual WorldModel& worldmodel_insert(WorldModel &_wmWorld) const;
	virtual CoachWorldModel& worldmodel_insert(CoachWorldModel &_cwmWorld) const;   // coach facility

    virtual ostream& ostream_insert(ostream &sout) const;
    int time; // current game time
};

ostream& operator<<(ostream &sout, const SensorData &d);

//WorldModel& operator+=(WorldModel &_wmWorld, const SensorData &_sdData);
//CoachWorldModel& operator+=(CoachWorldModel &_cwmWorld, const SensorData &_sdData);  // coach facility

#endif
