/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// visualdata.cpp Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "visualdata.h"

VisualData::VisualData()
{
    // Provide some initial values
    ball.valid = false;

    for(int i=0; i <NUM_OTHER_PLAYERS; ++i) {
        player[i].valid = false;
        player[i].team = TEAM_UNKNOWN;
        player[i].number = -1;
    }
}

VisualData::VisualData(int _time) : SensorData(_time)
{
}	

VisualData::~VisualData()
{
}

WorldModel& VisualData::worldmodel_insert(WorldModel &_wmWorld) const
{
	int i; 					// index for loops

	// update the TimeStamp of the worldmodel
	// setTime must be called first when updating the worldmodel
	_wmWorld.setTime(time);	
	_wmWorld.setVisualTimeStamp(time);	
//	INSPECT("visual data received with timestamp:" << time);
	
	// give the flags and lines to the worldmodel so that it can
	// calculate the worldmodel's origin (and, hence, the client player's poisition)	
	_wmWorld.computeOrigin(flag, line);
	
	// then copy the Visual Data of the ball into the ball worldmodel
	_wmWorld.updateWorldBall(ball);
	
	// then copy each player into the worldmodel
	for(i = 0; i < NUM_OTHER_PLAYERS; i++)
	{
  		_wmWorld.updatePlayer(player[i]);
	}
	
	return _wmWorld;
}

ostream& VisualData::ostream_insert(ostream &sout) const
{
/*
  SensorObject ball;
  SensorGoal goal[2];
  SensorPlayer player[21];
  SensorFlag flag[NUM_FLAGS];
  SensorLine line[NUM_LINES];
*/
  if(!ball.valid)  sout << "Ball object is invalid (don't know where it is)" << endl;
  else {
    sout << "Ball object is valid (seen)" << endl;
    sout << "Ball dist:   " << ball.dist << endl;
    sout << "Ball dir:    " << ball.dir << " radians" << endl;
    sout << "dist_change: " << ball.dist_change << endl;
    sout << "dir_change:  " << ball.dir_change << endl;

  }

   return sout;

}
