/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// worldmovableobject.h Fri Jun 8 2001
// Description: WorldMovableObjects are worldobjects that move.
//
//////////////////////////////////////////////////////////////////////

#ifndef _WORLDMOVABLEOBJECT_H_
#define _WORLDMOVABLEOBJECT_H_

#include "worldobject.h"
#include "angle.h"
#include "vector2d.h"


class WorldMovableObject: public WorldObject {
public:

  WorldMovableObject(double _dMaxVelocity,
		    double _dSize,
		    const Vector2d& _vAbsPosition);
  WorldMovableObject(double _dMaxVelocity, double _dSize);
	virtual ~WorldMovableObject();
	
	double getMaxVelocity();
	double getSize();
	int getConeTime();
	Vector2d getVelocity() const;

	void setSize(double _dSize);
	void setConeTime(int _iConeTime);
	void setMaxVelocity(double _dMaxVelocity);
	void setVelocity(double _dDistChange, double _dDirChange);
	void setVelocity(Vector2d _vVelocity);
	void increaseConeTime();
	
	void update(const WorldMovableObject& _wmoObject);
	
	ofstream& ofstream_insert(ofstream &_fout);
	ostream& ostream_insert(ostream &_out);	
	ifstream& ifstream_extract(ifstream &_in);

private:
  Vector2d 	vVelocity;
	double    dMaxVelocity;       // maximum LENGTH of velocity vector
  double    dSize;       // object radius
  int       iConeTime;   // time object spent in a certain view cone

};

#endif
