/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// worldobject.cpp Thu Jun 7 2001
// Description: This is the implementation of the WorldObject class
//							WorldObjects describe the position of items in the
//							WorldModel
//////////////////////////////////////////////////////////////////////

#include "worldobject.h"

WorldObject::WorldObject()
{
	setAbsPosition(Vector2d(0,0));
	setAge(UNKNOWN);
	fKnown = false;
}

WorldObject::WorldObject(const Vector2d &_vAbsPosition)
{
	setAbsPosition(_vAbsPosition);
	setAge(UNKNOWN);
	fKnown = false;
}

WorldObject::~WorldObject()
{
}

int WorldObject::getAge() const
{
	return iAge;
}

bool WorldObject::isKnown() const
{
	return fKnown;
}

Vector2d WorldObject::getAbsPosition() const
{
	return vAbsPosition;
}

void WorldObject::setAge(int _iAge)
{
	iAge = _iAge;
}

void WorldObject::incrementAge()
{
	if(isKnown()) iAge++;
}

void WorldObject::setAbsPosition(const Vector2d &_vAbsPosition)
{
	vAbsPosition = _vAbsPosition;
}

WorldObject& WorldObject::operator+=(const SensorObject &soObject)
{
	// TODO: should implement this sometime to take advantage of
	// function extending capabilites of C++

	return *this;
}


WorldObject& WorldObject::operator+=(const ExactGoal &_egGoal)
{
    if(_egGoal.valid)
    {
        setAge(0);
        setAbsPosition(Vector2d(_egGoal.x, _egGoal.y));
    }

    return *this;
}

/*
WorldObject& WorldObject::operator+=(const SensorGoal &sgGoal)
{
	if (sgGoal.valid)
	{
		// first adjust the age
		setAge(0);
	}
	else
	{
		if ((getAge() > UNKNOWN) && (getAge() < ETERNAL))
			incrementAge();
	}
		
	// WARNING: do we care if the goal is on the right or left side
	// of the field
	return *this;

}

WorldObject& WorldObject::operator+=(const SensorFlag &sfFlag)
{
	if (sfFlag.valid)
	{
		// first adjust the age
		setAge(0);
	}
	else
	{
		if ((getAge() > UNKNOWN) && (getAge() < ETERNAL))
			incrementAge();
	}
	
	return *this;

}

WorldObject& WorldObject::operator+=(const SensorLine &slLine)
{
	if (slLine.valid)
	{
		// first adjust the age
		setAge(0);
	}
	else
	{
		if ((getAge() > UNKNOWN) && (getAge() < ETERNAL))
			incrementAge();
	}
	
	return *this;
}
*/

ofstream& WorldObject::ofstream_insert(ofstream &_out)
{
	_out << "<worldobject>" << endl;	
		
	_out << "<abspos><vector><x>" << getAbsPosition().getX() << "</x>"
        << "<y>" << getAbsPosition().getY() << "</y></vector></abspos>" << endl;
	
	_out << "<age>" << getAge() << "</age>" << endl;

	_out << "</worldobject>" << endl;

	return _out;
}

ifstream& WorldObject::ifstream_extract(ifstream &_in) {
    // TODO: Something

    return _in;
}
